Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 6.0.43
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.valves
Class SSLValve

    java.lang.Object
      org.apache.catalina.valves.ValveBase
          org.apache.catalina.valves.SSLValve

All Implemented Interfaces:
  javax.management.MBeanRegistration, Contained, Valve

    public class SSLValve

extends ValveBase

When using mod_proxy_http, the client SSL information is not included in the protocol (unlike mod_jk and mod_proxy_ajp). To make the client SSL information available to Tomcat, some additional configuration is required. In httpd, mod_headers is used to add the SSL information as HTTP headers. In Tomcat, this valve is used to read the information from the HTTP headers and insert it into the request.

Note: Ensure that the headers are always set by httpd for all requests to prevent a client spoofing SSL information by sending fake headers.

In httpd.conf add the following:

     <IfModule ssl_module>
       RequestHeader set SSL_CLIENT_CERT "%{SSL_CLIENT_CERT}s"
       RequestHeader set SSL_CIPHER "%{SSL_CIPHER}s"
       RequestHeader set SSL_SESSION_ID "%{SSL_SESSION_ID}s"
       RequestHeader set SSL_CIPHER_USEKEYSIZE "%{SSL_CIPHER_USEKEYSIZE}s"
     </IfModule>

In server.xml, configure this valve under the Engine element in server.xml:

     <Engine ...>
       <Valve className="org.apache.catalina.valves.SSLValve" />
       <Host ... />
     </Engine>

Field Summary

Fields inherited from class org.apache.catalina.valves.ValveBase
`container, containerLog, controller, domain, info, mserver, next, oname, sm`

Constructor Summary
`SSLValve()`

Method Summary
`void` | `invoke(Request request, Response response)` The implementation-specific logic represented by this Valve.
`java.lang.String` | `mygetHeader(Request request, java.lang.String header)`

Methods inherited from class org.apache.catalina.valves.ValveBase
`backgroundProcess, createObjectName, event, getContainer, getContainerName, getController, getDomain, getInfo, getNext, getObjectName, getParentName, postDeregister, postRegister, preDeregister, preRegister, setContainer, setController, setNext, setObjectName, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### SSLValve

    public SSLValve()

Method Detail

### mygetHeader

    public java.lang.String mygetHeader(Request request,
                                        java.lang.String header)

### invoke

    public void invoke(Request request,
                       Response response)
                throws java.io.IOException,
                       javax.servlet.ServletException

  Description copied from class: `ValveBase`
  The implementation-specific logic represented by this Valve. See the Valve description for the normal design patterns for this method.

  This method MUST be provided by a subclass.

  Specified by:
    `invoke` in interface `Valve`
  Specified by:
    `invoke` in class `ValveBase`
  Parameters:
    `request` - The servlet request to be processed
    `response` - The servlet response to be created
  Throws:
    `java.io.IOException` - if an input/output error occurs
    `javax.servlet.ServletException` - if a servlet error occurs

Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 6.0.43
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2014 Apache Software Foundation. All Rights Reserved.